#include<bits/stdc++.h>
#define MAXN 150007
using namespace std;

const int inf=1e4;

int pt,n,a[MAXN],b[MAXN],c[MAXN];
int from[MAXN];

long long dp[MAXN];

struct line{
    int a;
    int b;
    int from;

    long long val(long long x){
        return (long long) a*x+b;
    }
};

long long intersec(line fr,line sc){
    long long x=(sc.b-fr.b)/(fr.a-sc.a);

    if(sc.val(x)<fr.val(x))x++;
    if(sc.val(x-1)>=fr.val(x-1))x--;

    return x;
}

struct CHT{
    deque<line> d;

    void addline(line s){
        while(!d.empty() and s.val(d.back().from)>=d.back().val(d.back().from)){
            d.pop_back();
        }

        if(d.empty())d.push_back({s.a,s.b,-inf});
        else d.push_back({s.a,s.b,intersec(d.back(),s)});
    }

    long long query(long long x){
        if(d.empty()){
            return -inf;
        }

        while(x<d.back().from)d.pop_back();
        return d.back().val(x);
    }
};

struct MST{
    CHT tree[4*MAXN];
    bool calc[4*MAXN];

    void addline(int v,int l,int r,int pos,line w){
        if(l==r){
            tree[v].addline(w);
            calc[v]=true;

            return;
        }else{
            int tt=(l+r)/2;

            if(pos<=tt)addline(2*v,l,tt,pos,w);
            else addline(2*v+1,tt+1,r,pos,w);
        }
    }

    void mergev(int x,int y,int z){
        calc[x]=true;

        int pt=0;
        for(int i=0;i<tree[y].d.size();i++){
            while(pt<tree[z].d.size() and tree[z].d[pt].a<tree[y].d[i].a){
                tree[x].addline(tree[z].d[pt]); pt++;
            }

            tree[x].addline(tree[y].d[i]);
        }

        while(pt<tree[z].d.size()){
            tree[x].addline(tree[z].d[pt]); pt++;
        }
    }

    void build(int v,int l,int r){
        if(calc[v])return;

        if(l==r){
            return;
        }else{
            int tt=(l+r)/2;
            build(2*v,l,tt);
            build(2*v+1,tt+1,r);

            mergev(v,2*v,2*v+1);
        }
    }

    long long query(int v,int l,int r,int ll,int rr,long long x){
        if(ll>rr)return -inf;

        if(l==ll and r==rr){
            build(v,l,r);
            return tree[v].query(x);
        }else{
            int tt=(l+r)/2;

            return max( query(2*v,l,tt,ll,min(tt,rr),x) , query(2*v+1,tt+1,r,max(tt+1,ll),rr,x) );
        }
    }
};

MST even,odd;

pair<int,int> tree[4*MAXN];

pair<int,int> combine(pair<int,int> fr,pair<int,int> sc){
    return {min(fr.first,sc.first),max(fr.second,sc.second)};
}

void build(int v,int l,int r){
    if(l==r){
        tree[v]={b[l],c[l]};
    }else{
        int tt=(l+r)/2;
        build(2*v,l,tt);
        build(2*v+1,tt+1,r);

        tree[v]=combine(tree[2*v],tree[2*v+1]);
    }
}

pair<int,int> info(int v,int l,int r,int ll,int rr){
    if(ll>rr)return {0,0};
    if(l==ll and r==rr)return tree[v];

    int tt=(l+r)/2;
    return combine(  info(2*v,l,tt,ll,min(tt,rr)) , info(2*v+1,tt+1,r,max(tt+1,ll),rr) );
}

bool good(int l,int r){
    int mid=(l+r)/2;

    pair<int,int> s=info(1,1,n,l,mid);
    if(s.first<1-l)return false;

    pair<int,int> t=info(1,1,n,mid+1,r);
    if(t.second<1-r)return false;

    return true;
}

int main(){

    //ios_base::sync_with_stdio(0);
    //cin.tie(0);
    //cout.tie(0);

    cin>>n;
    for(int i=1;i<=n;i++){
        cin>>a[i];

        b[i]=a[i]-i;
        c[i]=a[i]-(n-i+1);
    }
    build(1,1,n);

    pt=n;
    for(int i=n;i>=1;i--){
        while(pt-1>=1 and good(pt-1,i))pt--;
        from[i]=pt;
    }

    even.addline(1,0,n,0,{0,0,0});

    for(long long i=1;i<=n;i++){
        if(i%2==1){

            if(from[i]%2==0)from[i]++;

            dp[i]=even.query(1,0,n,from[i]-1,i,-i/2-1) + (i/2+1)*(i/2+1);
            odd.addline(1,0,n,2*(i/2+1),{2*(i/2+1),dp[i]+(i/2+1)*(i/2+1) - 2*(i/2+1),0});
        }else{
            if(from[i]%2==1)from[i]++;
            
            dp[i]=odd.query(1,0,n,from[i],i,-i/2) + i*i/4 + 2*(i/2) + 1;
            even.addline(1,0,n,i,{i,dp[i]+i*i/4,0});
        }
    }

    cout<<dp[n]<<"\n";

    return 0;
}