#include<bits/stdc++.h>
#include "circle.h"

#define MAXN 100007
using namespace std;

struct point{
    double x,y;
};

struct circle{
    double x,y,r;

    inline friend bool operator < (circle fr,circle sc){
        if(fr.x!=sc.x)return fr.x<sc.x;
        if(fr.y!=sc.y)return fr.y<sc.y;
        return fr.r<sc.r;
    }

    inline friend bool operator == (circle fr,circle sc){
        return fabs(fr.x-sc.x) + fabs(fr.y-sc.y) + fabs(fr.r-sc.r) <= 0.01;
    }
};

vector<circle> ans;

struct line{
    double k,m;
    double x=-1234;

    bool ver(){
        return k==0 and m==0 and x!=-1234;
    }
};

line perpen(line s,point t){
    if(s.ver())return {0,t.y,-1234};
    if(s.k==0)return {0,0,t.x};

    double k=-1.0/s.k;
    return {k,t.y-t.x*k,-1234};
}

line getline(point fr,point sc){
    if(fr.x==sc.x)return {0,0,fr.x};
    double k=(sc.y-fr.y)/(sc.x-fr.x);

    return {k,fr.y-k*fr.x};
}

point mid(point a,point b){
    return {(a.x+b.x)/2,(a.y+b.y)/2};
}

point intersect(line a,line b){
    if(a.ver() and b.ver())return {-1234,-1234};
    if(a.k==b.k)return {-1234,-1234};

    double x=(b.m-a.m)/(a.k-b.k);
    double y=a.k*x+a.m;

    return {x,y};
}

point p[MAXN];

double dist(point a,point b){
    return sqrt( (a.x-b.x)*(a.x-b.x) + (a.y-b.y)*(a.y-b.y) );
}

circle getcircle(point a,point b,point c){
    line aa,bb;
    aa=perpen(getline(b,c),mid(b,c));
    bb=perpen(getline(a,c),mid(a,c));

    point cc=intersect(aa,bb);
    return {cc.x,cc.y,dist(cc,a)};
}

circle w[MAXN];

void solve(int k){

    int m=50;

    for(int i=1;i<=m;i++){
        pair<double,double> s=sample_star();
        p[i]={s.first,s.second};
    }

    int br=0;
    for(int i=1;i<=m;i++){
        for(int f=i+1;f<=m;f++){
            for(int k=f+1;k<=m;k++){
                if(p[i].x==p[f].x and p[f].x==p[k].x)continue;
                if(p[i].y==p[f].y and p[f].y==p[k].y)continue;

                br++; w[br]=getcircle(p[i],p[f],p[k]);
            }
        }
    }

    sort(w+1,w+br+1);

    int cnt=0;
    for(int i=1;i<=br;i++){
        if(i>1 and w[i]==w[i+1])cnt++;
        else{
            if(cnt>20)ans.push_back(w[i]);
            cnt=0;
        }
    }

    for(int i=0;i<ans.size();i++){
        answer(ans[i].x,ans[i].y,ans[i].r);
    }

    return;
}
