#include <algorithm>
#include <array>
#include <cassert>
#include <climits>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <map>
#include <random>
#include <unordered_map>
#include <vector>
#include "circle.h"


using namespace std;

#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL

#define out(x) #x << " = " << x << "  "

const double EPS = 0.00001;




std::mt19937 gen( 69 );
int randNum( int lb, int ub ){
    std::uniform_int_distribution< int > dist( lb, ub );
    return dist( gen );
}

double getDist( const std::pair< double, double >& a, const std::pair< double, double >& b ){
    double nas = ( a.first - b.first ) * ( a.first - b.first ) + ( a.second - b.second ) * ( a.second - b.second );
    return nas;
}

typedef long double ld;
void solve( int k ){

    //std::set< std::pair< double, double > > stars;
    std::vector< std::pair< ld, ld > > stars;
    for( int i=0 ; i < 400 ; i++ ){
        auto curr = sample_star( );
        stars.push_back( curr );
    }

    //for( auto j : stars ) cerr << j.first << " " << j.second << endl;
    //cerr << endl;

    std::vector< std::pair< std::pair< ld, ld >, ld > > nas;
    int cnt = 0;
    while( !stars.empty() and cnt++ < 20 ){
        int ind1 = randNum(0, stars.size() );
        int ind2 = randNum(0, stars.size() );
        int ind3 = randNum(0, stars.size() );

        std::pair< ld, ld > coord1 = stars[ind1];
        std::pair< ld, ld > coord2 = stars[ind2];
        std::pair< ld, ld > coord3 = stars[ind3];

        ///cerr << out( coord1.first ) << out( coord1.second ) << endl;
        ///cerr << out( coord2.first ) << out( coord2.second ) << endl;
        ///cerr << out( coord3.first ) << out( coord3.second ) << endl;



        ld k11 = -2*coord1.first;
        ld k12 = -2*coord1.second;
        ld c1 = coord1.first * coord1.first + coord1.second * coord1.second;

        ld k21 = -2*coord2.first;
        ld k22 = -2*coord2.second;
        ld c2 = coord2.first * coord2.first + coord2.second * coord2.second;

        ld k31 = -2*coord3.first;
        ld k32 = -2*coord3.second;
        ld c3 = coord3.first * coord3.first + coord3.second * coord3.second;

        ld KK11 = k11 - k21;
        ld KK12 = k12 - k22;
        ld CC1 = c2 - c1;

        ld KK21 = k11 - k31;
        ld KK22 = k12 - k32;
        ld CC2 = c3 - c1;

        ld del = KK11 / KK21;

        ld KKK = KK12 - ( KK22 * del );
        ld CCC = CC1 - ( CC2 * del );

        ld Ay = CCC / KKK;

        // KK11 * Ax + KK12 * Ay = CC1
        // Ax = ( CC1 - KK12 * Ay ) / KK11
        ld Ax = ( CC1 - KK12 * Ay ) / KK11;

        ///cerr << out( Ax ) << out( Ay ) << endl;

        std::pair< ld, ld > center;
        center.first = Ax; center.second = Ay;

        ld currR = getDist( coord1, center );
        cerr << out( currR ) << endl;

        int currCnt = 0;
        std::vector< std::pair< ld, ld > > newStars;
        for( int i=0 ; i < stars.size() ; i++ ){
            auto j = stars[i];
            ld currDist = getDist( center, j );
            //cerr << out( i ) << out( currDist ) << out( currDist - c) << endl;
            if( EPS > currDist - currR and currDist - currR > -EPS ){
                currCnt ++;
            }else{
                newStars.push_back( j );
            }
        }

        ///cerr << out( currCnt ) << endl;
        if( currCnt > 15 ){
            stars = newStars;
            nas.push_back({ center, currR });
        }

    }

    for( auto j : nas ){
        ///cerr << j.first.first << " " << j.first.second << " ; " << sqrt( j.second ) << endl;
        answer( j.first.first, j.first.second, sqrt( j.second ) );
    }

}

