/*
    Не сме безгрешни но сме истински,
    Обичаме и тези дето ни нападат,
    защото имаме добри души...
    Души, които могат всичко да прощават!
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

template <typename T>
using OSet = __gnu_pbds::tree <T, __gnu_pbds::null_type, std::less <T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

typedef long long llong;
const int MAXN = 500000 + 10;
const int MAXLOG = 19;
const llong INF = 1e18;
const int INTINF = 1e9;

int n;
struct Sparse
{
    int sparse[MAXLOG][MAXN];
    int getLog[MAXN];

    void build(int a[])
    {
        for (int i = 1 ; i <= n ; ++i)
        {
            sparse[0][i] = a[i];
        }

        for (int lg = 1 ; (1 << lg) <= n ; ++lg)
        {
            for (int i = 1 ; i + (1 << lg) - 1 <= n ; ++i)
            {
                sparse[lg][i] = std::min(sparse[lg - 1][i], sparse[lg - 1][i + (1 << lg - 1)]); 
            }
        }

        for (int i = 1 ; i <= n ; ++i)
        {
            getLog[i] = getLog[i - 1];
            if ((1 << getLog[i] + 1) < i) getLog[i]++;
        }
    }

    int findMIN(int l, int r)
    {
        int lg = getLog[r - l + 1];
        return std::min(sparse[lg][l], sparse[lg][r - (1 << lg) + 1]);
    }
};

int a[MAXN];
int jump[MAXN];
Sparse sparsePlus;
Sparse sparseMinus;

bool isOK(int l, int r)
{
    int mid = (l + r) / 2;
    for (int i = l ; i <= mid ; ++i)
    {
        if (a[i] < 1 + (i - l))
        {
            return false;
        }
    }

    for (int i = mid + 1 ; i <= r ; ++i)
    {
        if (a[i] < 1 + (mid - l) - (i - mid))
        {
            return false;
        }
    }

    return true;
    assert((r - l + 1) & 1);
    // int mid = (l + r) / 2;
    return sparseMinus.findMIN(l, mid) >= 1 - l && sparsePlus.findMIN(mid, r) >= 1 - l;
}

llong dp[MAXN];
void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] += i;
    }

    sparsePlus.build(a);

    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] -= 2 * i;
    }

    sparseMinus.build(a);
    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] += i;
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        if (i > 3)
        {
            jump[i] = jump[i - 2];
        }

        jump[i] = std::max(jump[i], i);
        while ((jump[i] + 2) <= n && isOK(i, jump[i] + 2))
        {
            jump[i] += 2;
        }
    }

    for (int i = n ; i >= 1 ; --i)
    {
        for (int j = i ; j <= jump[i] ; ++j)
        {
            dp[i] = std::max(dp[i], dp[j + 1] + 1LL * (j - i + 2) * (j - i + 2));
        }
    }

    std::cout << dp[1] / 4 << '\n';
}

void input()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}