/*
    Не сме безгрешни но сме истински,
    Обичаме и тези дето ни нападат,
    защото имаме добри души...
    Души, които могат всичко да прощават!
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <queue>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

template <typename T>
using OSet = __gnu_pbds::tree <T, __gnu_pbds::null_type, std::less <T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

typedef long long llong;
const int MAXN = 500000 + 10;
const int MAXLOG = 19;
const llong INF = 1e18;
const int INTINF = 1e9;

int n;
struct SegmentTreeMIN
{
    int tree[4*MAXN];
    void build(int l, int r, int node, int a[])
    {
        if (l == r)
        {
            tree[node] = a[l];
            return;
        }

        int mid = l + r >> 1;
        build(l, mid, 2*node, a);
        build(mid + 1, r, 2*node + 1, a);
        tree[node] = std::min(tree[2*node], tree[2*node + 1]);
    }

    int query(int l, int r, int node, int queryL, int queryR)
    {
        if (queryL <= l && r <= queryR)
        {
            return tree[node];
        }

        int mid = l + r >> 1;
        int ans = INTINF;

        if (queryL <= mid) ans = std::min(ans, query(l, mid, 2*node, queryL, queryR));
        if (mid + 1 <= queryR) ans = std::min(ans, query(mid + 1, r, 2*node + 1, queryL, queryR));
        return ans;
    }

    void build(int a[])
    {
        build(1, n + 1, 1, a);
    }

    int findMIN(int l, int r)
    {
        return query(1, n + 1, 1, l, r);
    }
};

struct Sparse
{
    int sparse[MAXLOG][MAXN];
    int getLog[MAXN];

    void build(int a[])
    {
        for (int i = 1 ; i <= n ; ++i)
        {
            sparse[0][i] = a[i];
        }

        for (int lg = 1 ; (1 << lg) <= n ; ++lg)
        {
            for (int i = 1 ; i + (1 << lg) - 1 <= n ; ++i)
            {
                sparse[lg][i] = std::min(sparse[lg - 1][i], sparse[lg - 1][i + (1 << lg - 1)]); 
            }
        }

        for (int i = 1 ; i <= n ; ++i)
        {
            getLog[i] = getLog[i - 1];
            if ((1 << getLog[i] + 1) < i) getLog[i]++;
        }
    }

    int findMIN(int l, int r)
    {
        int lg = getLog[r - l + 1];
        return std::min(sparse[lg][l], sparse[lg][r - (1 << lg) + 1]);
    }
};

struct SegmentTree
{
    struct CHT
    {
        struct Line
        {
            int a;
            llong b;
            int to;

            inline llong at(const llong &x) const
            {
                return a * x + b;
            }
        };

        int intersect(const Line &new_line, const Line &old_line)
        {
            // assert(old_line.a > new_line.a);
            // assert(old_line.b < new_line.b);
            // return (old_line.b - new_line.b) / (old_line.a - new_line.a) + (((old_line.b - new_line.b) % (old_line.a - new_line.a)) > 0);

            int l = -2 * MAXN, r = 2 * MAXN, mid;
            while (l < r - 1)
            {
                mid = (l + r) / 2;
                if (new_line.at(mid) >= old_line.at(mid)) l = mid;
                else r = mid;
            }

            return l;
        }

        std::deque <Line> cht;
        void push(int a, llong b)
        {
            Line new_line = {a, b, 0};
            while (cht.size() && cht[0].at(cht[0].to) <= new_line.at(cht[0].to))
            {
                cht.pop_front();
            }
            
            if (cht.size()) cht.push_front({a, b, intersect(new_line, cht[0])});
            else cht.push_front(new_line);
        }

        llong query(llong x)
        {
            while (cht.size() >= 2 && x <= cht[cht.size() - 2].to)
            {
                // if (cht[0].a == -18) std::cout << "pop: " << cht[0].a << ' ' << cht[0].b << ' ' << cht[0].to << ' ' << x << '\n'; 
                cht.pop_back();
            }

            assert(cht.size());
            // if (x == 3) std::cout << "     important\n";
            // std::cout << "query: " << x << ' ' << cht.back().a << ' ' << cht.back().b << ' ' << cht.back().at(x) << '\n';
            return cht.back().at(x);
        }
    };

    CHT tree[4*MAXN];
    void build(int l, int r, int node)
    {
        tree[node].push(-MAXN, - 1LL * MAXN * MAXN);
        if (l == r)
        {
            return;
        }

        int mid = l + r >> 1;
        build(l, mid, 2*node);
        build(mid + 1, r, 2*node + 1);
    }

    void update(int l, int r, int node, int queryPos, int a, llong b)
    {
        tree[node].push(a, b);
        if (l == r)
        {
            return;
        }

        int mid = l + r >> 1;
        if (queryPos <= mid) update(l, mid, 2*node, queryPos, a, b);
        else update(mid + 1, r, 2*node + 1, queryPos, a, b);
    }

    llong query(int l, int r, int node, int queryL, int queryR, llong x)
    {
        llong ans = -INF;
        if (queryL <= l && r <= queryR)
        {
            return tree[node].query(x);
        }

        int mid = l + r >> 1;

        if (queryL <= mid) ans = std::max(ans, query(l, mid, 2*node, queryL, queryR, x));
        if (mid + 1 <= queryR) ans = std::max(ans, query(mid + 1, r, 2*node + 1, queryL, queryR, x));
        return ans;
    }

    void build()
    {
        build(1, n + 1, 1);
    }

    void update(int idx, llong a, llong b)
    {
        update(1, n + 1, 1, idx, a, b);
    }

    llong query(int l, int r, llong x)
    {
        return query(1, n + 1, 1, l, r, x);
    }
};

int a[MAXN];
int jump[MAXN];
SegmentTreeMIN sparsePlus;
SegmentTreeMIN sparseMinus;
SegmentTree tree[2];

bool isOK(int l, int r)
{
    assert((r - l + 1) & 1);
    int mid = (l + r) / 2;
    return sparseMinus.findMIN(l, mid) >= 1 - l && sparsePlus.findMIN(mid, r) >= 1 - l + 2 * mid;
}

llong dp[MAXN];
void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] += i;
    }

    sparsePlus.build(a);

    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] -= 2 * i;
    }

    sparseMinus.build(a);
    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] += i;
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        if (i > 3)
        {
            jump[i] = jump[i - 2];
        }

        jump[i] = std::max(jump[i], i);
        while ((jump[i] + 2) <= n && isOK(i, jump[i] + 2))
        {
            jump[i] += 2;
        }
    }

    tree[0].build();
    tree[1].build();
    tree[(n + 1) & 1].update(n + 1, - 2 * (n + 2), 1LL * (n + 2) * (n + 2));
    for (int i = n ; i >= 1 ; --i)
    {
        dp[i] = 1LL * i * i + tree[(i & 1) ^ 1].query(i + 1, jump[i] + 1, i);
        // std::cout << "dp: " << i << " = " << dp[i] << ' ' << i * i << '\n';
        tree[i & 1].update(i, -2 * (i + 1), 1LL * (i + 1) * (i + 1) + dp[i]);
    }

    std::cout << dp[1] / 4 << '\n';
}

void input()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}