/*
    Не сме безгрешни но сме истински,
    Обичаме и тези дето ни нападат,
    защото имаме добри души...
    Души, които могат всичко да прощават!
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <queue>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

template <typename T>
using OSet = __gnu_pbds::tree <T, __gnu_pbds::null_type, std::less <T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

typedef long long llong;
const int MAXN = 250000 + 10;
const llong INF = 1e18;
const int INTINF = 1e9;

int n;
struct SegmentTreeMIN
{
    int tree[4*MAXN];
    void build(int l, int r, int node, int a[])
    {
        if (l == r)
        {
            tree[node] = a[l];
            return;
        }

        int mid = l + r >> 1;
        build(l, mid, 2*node, a);
        build(mid + 1, r, 2*node + 1, a);
        tree[node] = std::min(tree[2*node], tree[2*node + 1]);
    }

    int query(int l, int r, int node, int queryL, int queryR)
    {
        if (queryL <= l && r <= queryR)
        {
            return tree[node];
        }

        int mid = l + r >> 1;
        int ans = INTINF;

        if (queryL <= mid) ans = std::min(ans, query(l, mid, 2*node, queryL, queryR));
        if (mid + 1 <= queryR) ans = std::min(ans, query(mid + 1, r, 2*node + 1, queryL, queryR));
        return ans;
    }

    void build(int a[])
    {
        build(1, n + 1, 1, a);
    }

    int findMIN(int l, int r)
    {
        return query(1, n + 1, 1, l, r);
    }
};

struct Current
{
    int l, r;
    int idx;
};

int a[MAXN];
int jump[MAXN];
SegmentTreeMIN sparsePlus;
SegmentTreeMIN sparseMinus;

bool isOK(int l, int r)
{
    assert((r - l + 1) & 1);
    int mid = (l + r) / 2;
    return sparseMinus.findMIN(l, mid) >= 1 - l && sparsePlus.findMIN(mid, r) >= 1 - l + 2 * mid;
}

int firstWith[MAXN];
int binary(int value)
{
    if (firstWith[value] == 0) return n + 1;
    return firstWith[value];
}

std::deque <Current> v[2]; 
llong dp[MAXN];

llong costWith(int idx, int i)
{
    // std::cout << "  cost with:" << idx << ' ' << i << ' ' << dp[idx] << ' ' << (idx + 1 - i) * (idx + 1 - i) << '\n';
    return dp[idx] + 1LL * (idx + 1 - i) * (idx + 1 - i);
}

void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] += i;
    }

    sparsePlus.build(a);

    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] -= 2 * i;
    }

    sparseMinus.build(a);
    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] += i;
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        if (i > 3)
        {
            jump[i] = jump[i - 2];
        }

        jump[i] = std::max(jump[i], i);
        while ((jump[i] + 2) <= n && isOK(i, jump[i] + 2))
        {
            jump[i] += 2;
        }
    }
    
    for (int i = 1 ; i <= n + 1 ; ++i) firstWith[i] = n + 1;
    for (int i = n ; i >= 1 ; --i)
    {
        firstWith[jump[i] + 1] = i;
    }

    for (int i = n - 1 ; i >= 1 ; --i)
    {
        firstWith[i] = std::min(firstWith[i], firstWith[i + 2]);
        // std::cout << "first with: " << i << " = " << firstWith[i] << '\n';
    }
    
    // std::cout << "binary: " << binary(n + 1) << '\n';
    v[n & 1].push_back({binary(n + 1), n, n + 1});
    for (int i = n ; i >= 1 ; --i)
    {
        while (v[i & 1].size() && v[i & 1].back().l > i)
        {
            v[i & 1].pop_back();
        }

        int l = -1, r = v[i & 1].size(), mid;
        while (l < r - 1)
        {
            mid = l + r >> 1;
            if (v[i & 1][mid].l > i) l = mid;
            else r = mid;
        }

        l = r;
        // std::cout << "vector: " << i << ' ' << l << "\n";
        // for (const auto &x : v[i & 1])
        // {
        //     std::cout << x.l << ' ' << x.r << ' ' << x.idx << '\n';
        // }   

        // if (l == -1)
        // {
        //     exit(0);
        // }
        assert(l != -1);
        dp[i] = dp[v[i & 1][l].idx] + 1LL * (v[i & 1][l].idx + 1 - i) * (v[i & 1][l].idx + 1 - i);
        // std::cout << "opt: " << i << " = " << v[i & 1][l].idx << ' ' << dp[i] << '\n';
        while (v[(i + 1) & 1].size() && costWith(v[(i + 1) & 1].back().idx, v[(i + 1) & 1].back().l) <= costWith(i, v[(i + 1) & 1].back().l))
        {
            // std::cout << "will pop: " << v[(i + 1) & 1].back().idx << ' ' << costWith(v[(i + 1) & 1].back().idx, v[(i + 1) & 1].back().l) << ' ' << costWith(i, v[(i + 1) & 1].back().l) << '\n';
            v[(i + 1) & 1].pop_back();
        }  

        if (v[(i + 1) & 1].empty())
        {
            // std::cout << "here: " << binary(i) << ' ' << i - 1 << ' ' << i << '\n';
            if (binary(i) <= i - 1) v[(i + 1) & 1].push_back({binary(i), i - 1, i});
        } else if (v[(i + 1) & 1].back().l < i - 1)
        {
            int ll = v[(i + 1) & 1].back().l - 1, rr = std::min(i - 1, v[(i + 1) & 1].back().r), mid;
            while (ll < rr - 1)
            {
                mid = ll + rr >> 1;
                if (costWith(v[(i + 1) & 1].back().idx, mid) > costWith(i, mid)) ll = mid;
                else rr = mid;
            }
            
            assert(rr != v[(i + 1) & 1].back().l);
            l = std::max(rr, binary(i));
            if (l <= i - 1)
            {
                v[(i + 1) & 1].back().r = l - 1;
                v[(i + 1) & 1].push_back({l, i - 1, i});
            }

            if (binary(i) < v[(i + 1) & 1][0].l)
            {
                v[(i + 1) & 1].push_front({binary(i), v[(i + 1) & 1][0].l - 1, i});
            }
        }
    }

    std::cout << dp[1] / 4 << '\n';
}

void input()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}