#include<bits/stdc++.h>
#include "circle.h"

#define INF 1e9

using namespace std;

mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());
unordered_map<double, int> mp;
int occ[500005];

struct Point
{
    double x, y;
}arr[505];
struct Circle
{
    Point o;
    double R;
    double operator() ()
    {
        return o.x * o.y / R;
    }
};
unordered_map<double, Circle> trans;

struct Line
{
    double a, b;
};
struct Query
{
    Circle c;
    int occ;
    bool operator<(Query other) const
    {
        return occ < other.occ;
    }
};

Line findRelation(Point a, Point b)
{
    if(a.x == b.x || a.y == b.y) return {INF, INF};
    Line l;
    l.a = (b.y - a.y) / (b.x - a.x);
    l.b = ((b.x * b.x) + (b.y * b.y) - (a.x * a.x) - (a.y * a.y)) / (2.0 * (b.x - a.x));
    return l;
}
Circle FindCircle(Point a, Point b, Point c)
{
    Line r1 = findRelation(a, b);
    Line r2 = findRelation(b, c);
    Line r3 = findRelation(a, c);
    if(r1.a == r1.b && r1.b == INF) swap(r1, r3);
    if(r2.a == r2.b && r2.b == INF) swap(r2, r3);
    Circle ci;
    ci.o.x = (-r1.a / r2.a) * r2.b + r1.b;
    ci.o.y = (ci.o.x - r1.b) / r1.a;
    ci.R = sqrt((a.x - ci.o.x) * (a.x - ci.o.x) + (a.y - ci.o.y) * (a.y - ci.o.y));
    return ci;
}
long long gen()
{
    return rng() % 500;
}
void solve(int k)
{
    for(int i = 0; i < 500; i ++)
    {
        pair<double, double> p = sample_star();
        arr[i] = {p.first, p.second};
    }
    for(int i = 0; i < 500; i ++)
    {
        int ind1 = gen(), ind2 = gen(), ind3 = gen();
        while(ind2 == ind1) ind2 = gen();
        while(ind3 == ind1 || ind3 == ind2) ind3 = gen();
        Circle c = FindCircle(arr[ind1], arr[ind2], arr[ind3]);
        double h = c();
        mp[h] ++;
        trans[h] = c;
    }
    int sz = 0;
    priority_queue<Query> pq;
    for(unordered_map<double, int>::iterator it = mp.begin(); it != mp.end(); it ++)
    {
        pq.push({trans[it->first], it->second});
    }
    sort(occ, occ + sz);
    while(k --)
    {
        Circle cc = pq.top().c;
        cout<<cc.o.x<<" "<<cc.o.y<<" "<<cc.R<<endl;
        answer(cc.o.x, cc.o.y, cc.R);
        pq.pop();
    }
}

