#include "circle.h"
#include<bits/stdc++.h>
#define x first
#define y second

using namespace std;

const double EPS=0.0001;

typedef pair<double,double> pdd;

mt19937 mt(666);

vector<pdd > v;
vector<pair<pdd, double> > circs;

pair<pdd, double> getCircle(int i1,int i2,int i3)
{
    auto p1=v[i1];
    auto p2=v[i2];
    auto p3=v[i3];

    double kx=2*(p2.x-p1.x);
    double ky=2*(p2.y-p1.y);
    double mx=2*(p3.x-p1.x);
    double my=2*(p3.y-p1.y);
    double kc=p1.x*p1.x-p2.x*p2.x+p1.y*p1.y-p2.y*p2.y;
    double mc=p1.x*p1.x-p3.x*p3.x+p1.y*p1.y-p3.y*p3.y;

    double l=ky-kx*my/mx;
    double s=kc-kx*mc/mx;

    double b=-s/l;
    double a=(-ky*b-kc)/kx;
    double r=sqrt((p1.x-a)*(p1.x-a)+(p1.y-b)*(p1.y-b));

    return {{a,b},r};
}

bool eq(double a,double b)
{
    if(abs(a-b)<EPS) return 1;
    return 0;
}

bool isOn(pdd A, pair<pdd, double> cur)
{
    auto c=cur.first;
    auto r=cur.second;

    if(eq((A.x-c.x)*(A.x-c.x)+(A.y-c.y)*(A.y-c.y), r*r)) return 1;
    return 0;
}

void solve(int k)
{
    int n=500;
    for(int i=0;i<n;i++)
    {
        v.push_back(sample_star());
    }

    while(1)
    {
        int i1=0,i2=0,i3=0;
        i1=mt()%(v.size()-2);
        i2=mt()%(v.size()-i1-2)+i1+1;
        i3=mt()%(v.size()-i2-1)+i2+1;

        auto cur=getCircle(i1,i2,i3);
        //cout<<cur.x.x<<" "<<cur.x.y<<" "<<cur.y<<endl;

        bool fl=0;
        vector<pdd> tmp;
        tmp.reserve(v.size());
        for(int i=0;i<v.size();i++)
        {
            if(i==i1 || i==i2 || i==i3) continue;
            if(isOn(v[i],cur))
            {
                fl=1;//cout<<99999<<endl;
            }
            else tmp.push_back(v[i]);
        }

        if(fl)
        {
            circs.push_back(cur);
            v=tmp;
        }

        if(circs.size()>=k) break;
    }

    for(auto cur: circs)
    {
        answer(cur.x.x, cur.x.y, cur.y);
    }
}
