#include "circle.h"
#include<bits/stdc++.h>
#define x first
#define y second

//#define double long double

using namespace std;

const long double EPS=0.0001;

typedef pair<double,double> pdd;
typedef pair<long double,long double> pldld;
typedef double db;
typedef long double ldb;

mt19937 mt(73292);

vector<pldld > v;
vector<pair<pldld, ldb> > circs;

pair<pldld, ldb> getCircle(int i1,int i2,int i3)
{
    pldld p1=v[i1];
    pldld p2=v[i2];
    pldld p3=v[i3];

    ldb kx=2*(p2.x-p1.x);
    ldb ky=2*(p2.y-p1.y);
    ldb mx=2*(p3.x-p1.x);
    ldb my=2*(p3.y-p1.y);
    ldb kc=p1.x*p1.x-p2.x*p2.x+p1.y*p1.y-p2.y*p2.y;
    ldb mc=p1.x*p1.x-p3.x*p3.x+p1.y*p1.y-p3.y*p3.y;

    ldb l=ky-kx/mx*my;
    ldb s=kc-kx/mx*mc;

    ldb b=-s/l;
    ldb a=(-ky*b-kc)/kx;
    ldb r2=(p1.x-a)*(p1.x-a)+(p1.y-b)*(p1.y-b);

    return {{a,b},r2};
}

bool eq(ldb a,ldb b)
{
    if(abs(a-b)<EPS) return 1;
    return 0;
}

bool isOn(pldld A, pair<pldld, ldb> cur)
{
    auto c=cur.first;
    auto r2=cur.second;

    if(eq((A.x-c.x)*(A.x-c.x)+(A.y-c.y)*(A.y-c.y), r2)) return 1;
    return 0;
}

void solve(int k)
{
    int n=300;
    for(int i=0;i<n;i++)
    {
        v.push_back(sample_star());
    }

    while(1)
    {
        if(v.size()<3) cout<<1/0<<endl;
        int i1=0,i2=0,i3=0;
        /*i1=mt()%(v.size()-2);
        i2=mt()%(v.size()-i1-2)+i1+1;
        i3=mt()%(v.size()-i2-1)+i2+1;*/
        while(i1==i2 || i2==i3 || i1==i3)
        {
            i1=mt()%v.size();
            i2=mt()%v.size();
            i3=mt()%v.size();
        }

        auto cur=getCircle(i1,i2,i3);
        //cout<<cur.x.x<<" "<<cur.x.y<<" "<<cur.y<<endl;

        int fl=0;
        vector<pldld> tmp;
        //tmp.reserve(v.size());
        for(int i=0;i<v.size();i++)
        {
            if(i==i1 || i==i2 || i==i3) continue;
            if(isOn(v[i],cur))
            {
                fl++;//cout<<99999<<endl;
            }
            else tmp.push_back(v[i]);
        }

        if(fl)
        {
            circs.push_back(cur);
            v=tmp;
        }

        if(circs.size()>=k) break;
    }

    for(auto cur: circs)
    {
        answer(cur.x.x, cur.x.y, sqrt(cur.y));
    }
}
