#include <iostream>
#include <queue>
using namespace std;
const int MAXN = 5 * 1e5 + 1;
long long arr[MAXN];
priority_queue< pair<long long, int> > h;
long long tree[8 * MAXN][2];
long long n;
long long INF = 1e9 + 1;
int marked_left[MAXN], marked_right[MAXN];
void build(int curr, int from, int to, bool dir) {
    if (from == to) {
        if (dir == 0) {
            long long one = 1;
            tree[curr][dir] = max(from - arr[from] + 1, one);
        } else {
            tree[curr][dir] = max(-from - arr[from], -n);
        }
    } else {
        build(curr * 2, from, (from + to) / 2, dir);
        build(curr * 2 + 1, (from + to) / 2 + 1, to, dir);
        tree[curr][dir] = max(tree[curr * 2][dir], tree[curr * 2 + 1][dir]);
    }
}
long long query(int curr, int from, int to, bool dir, int l, int r) {
    if (l <= from && to <= r) {
        return tree[curr][dir];
    }
    if (l <= to && from <= r) {
        return max(query(curr * 2, from, (from + to) / 2, dir, l, r), query(curr * 2 + 1, (from + to) / 2 + 1, to, dir, l, r));
    } else {
        return -INF;
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> arr[i];
    }
    build(1, 1, n, 0);
    build(1, 1, n, 1);
    for (int i = 1; i <= n; i++) {
        int l = query(1, 1, n, 0, 1, i);
        int r = -query(1, 1, n, 1, i, n);
//        cout << min(i - l + 1, r - i + 1) << ' ';
        h.push({min(i - l + 1, r - i + 1), i});
    }
//    cout << '\n';
    for (int i = 1; i <= n; i++) {
        marked_right[i] = 0;
        marked_left[i] = 0;
    }
    long long ans = 0;
    while (!h.empty()) {
        auto curr = h.top();
        if (curr.first <= 0) {
            break;
        }
        if (marked_right[curr.second - curr.first + 1] == 0 && marked_left[curr.second + curr.first - 1] == 0) {
            h.pop();
            ans += curr.first * curr.first;
            for (long long i = curr.second - curr.first + 1; i <= curr.second + curr.first - 1; i++) {
                marked_left[i] = i - (curr.second - curr.first + 1) + 1;
                marked_right[i] = (curr.second + curr.first - 1) - i + 1;
            }
        } else {
            curr.first -= max(marked_right[curr.second - curr.first + 1], marked_left[curr.second + curr.first - 1]);
            h.pop();
            h.push(curr);
        }
    }
    cout << ans << '\n';
    return 0;
}
