#include"circle.h"
#include <algorithm>
#include <array>
#include <cassert>
#include <climits>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <map>
#include <random>
#include <unordered_map>
#include <vector>
double absD(double x, double y)
{
    if (x>y) return x-y;
    return y-x;
}
double dist(std::pair<double,double> pr, std::pair<double,double> vt)
{
    double xx=vt.first-pr.first;
    xx*=xx;
    double yy=vt.second-pr.second;
    yy*=yy;
    double sb=xx+yy;
    sb=sqrt(sb);
    return sb;
}
std::pair< std::pair<double,double> , bool > simetrala(std::pair<double,double> pr, std::pair<double,double> vt)
{
    std::pair<double,double> srpv = {(pr.first+vt.first)/2,(pr.second+vt.second)/2};
    if (vt.second==pr.second)
    {
        return { {srpv.first,srpv.first} , 1 };
    }
    double a=(pr.first-vt.first)/(vt.second-pr.second);
    double b=srpv.second-a*srpv.first;
    return {{a,b},0};
}
std::pair< std::pair<double,double> , double> findCirc( std::pair<double,double> pr, std::pair<double,double> vt, std::pair<double,double> tr )
{
    double a=dist(pr,vt);
    double b=dist(tr,vt);
    double c=dist(pr,tr);
    double p=(a+b+c)/2;
    double face=sqrt( p*(p-a)*(p-b)*(p-c) );
    double R = (a*b*c)/(4*face);
    if (R>=500000 || R<=-1*500000) return {{0,0},R};
    //std::cout<<pr.first<<" "<<pr.second<<"\n";
    //std::cout<<vt.first<<" "<<vt.second<<"\n";
    //std::cout<<tr.first<<" "<<tr.second<<"\n";
    //std::cout<<a<<" "<<b<<" "<<c<<" "<<p<<" "<<face<<" "<<R<<"\nkraiii\n";
    std::pair< std::pair<double,double> , bool > sim1=simetrala(pr,vt);
    std::pair< std::pair<double,double> , bool > sim2=simetrala(tr,vt);
    double x,y;
    if (sim1.second==1)
    {
        x=sim1.first.first;
        y=sim2.first.first*x+sim2.first.second;
    }
    else if (sim2.second==1)
    {
        x=sim2.first.first;
        y=sim1.first.first*x+sim1.first.second;
    }
    else
    {
        x=(sim2.first.second-sim1.first.second)/(sim1.first.first-sim2.first.first);
        y=sim1.first.first*x+sim1.first.second;
    }
    //std::cout<<R<<" "<<x<<" "<<y<<"\nkraiii222\n";
    return { {x,y} , R };
}
void solve(int k)
{
    int br=20;
    std::vector<std::pair<double, double>> vv;
    for (int q=0;q<br;q++)
    {
        vv.push_back(sample_star());
        //std::cout<<vv[q].first<<" "<<vv[q].second<<"\n";
    }
    random_shuffle(vv.begin(),vv.end());
    int mks=(1<<br);
    for (int msk=0;msk<mks;msk++)
    {
        std::vector<std::pair<double, double>> nl,ed;
        for (int q=0;q<br;q++)
        {
            if ((msk>>q)%2==1) nl.push_back(vv[q]);
            else ed.push_back(vv[q]);
        }
        if (nl.size()<3 || ed.size()<3) continue;
        bool nula=true;
        std::pair< std::pair<double,double> , double> nlc=findCirc(nl[0],nl[1],nl[2]);
        for (int q=1;q+2<nl.size();q++)
        {
            std::pair< std::pair<double,double> , double> nld=findCirc(nl[q],nl[q+1],nl[q+2]);
            if (absD(nlc.first.first,nld.first.first)>=0.001 || absD(nlc.first.second,nld.first.second)>=0.001 || absD(nlc.second,nld.second)>=0.001)
            {
                nula=false;
                break;
            }
        }
            if (nlc.second>=500000 || nlc.second<=-1*500000)
            {
                nula=false;
            }
            if (nlc.first.first>=500000 || nlc.first.first<=-1*500000)
            {
                nula=false;
            }
            if (nlc.first.second>=500000 || nlc.first.second<=-1*500000)
            {
                nula=false;
            }
        bool edno=true;
        std::pair< std::pair<double,double> , double> edc=findCirc(ed[0],ed[1],ed[2]);
        for (int q=1;q+2<ed.size();q++)
        {
            std::pair< std::pair<double,double> , double> edd=findCirc(ed[q],ed[q+1],ed[q+2]);
            if (absD(edc.first.first,edd.first.first)>=0.001 || absD(edc.first.second,edd.first.second)>=0.001 || absD(edc.second,edd.second)>=0.001)
            {
                edno=false;
                break;
            }
        }
            if (edc.second>=500000 || edc.second<=-1*500000)
            {
                nula=false;
            }
            if (edc.first.first>=500000 || edc.first.first<=-1*500000)
            {
                nula=false;
            }
            if (edc.first.second>=500000 || edc.first.second<=-1*500000)
            {
                nula=false;
            }

        if (edno && nula)
        {
            answer(nlc.first.first,nlc.first.second,nlc.second);
            answer(edc.first.first,edc.first.second,edc.second);
            return;
        }
    }
    std::cout<<"NQMA\n";
}

