#include"circle.h"
#include <algorithm>
#include <array>
#include <cassert>
#include <climits>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <map>
#include <random>
#include <unordered_map>
#include <vector>
double absD(double x, double y)
{
    if (x>y) return x-y;
    return y-x;
}
double dist(std::pair<double,double> pr, std::pair<double,double> vt)
{
    double xx=vt.first-pr.first;
    xx*=xx;
    double yy=vt.second-pr.second;
    yy*=yy;
    double sb=xx+yy;
    sb=sqrt(sb);
    return sb;
}
std::pair< std::pair<double,double> , bool > simetrala(std::pair<double,double> pr, std::pair<double,double> vt)
{
    std::pair<double,double> srpv = {(pr.first+vt.first)/2,(pr.second+vt.second)/2};
    if (vt.second==pr.second)
    {
        return { {srpv.first,srpv.first} , 1 };
    }
    double a=(pr.first-vt.first)/(vt.second-pr.second);
    double b=srpv.second-a*srpv.first;
    return {{a,b},0};
}
std::pair< std::pair<double,double> , double> findCirc( std::pair<double,double> pr, std::pair<double,double> vt, std::pair<double,double> tr )
{
    double a=dist(pr,vt);
    double b=dist(tr,vt);
    double c=dist(pr,tr);
    double p=(a+b+c)/2;
    double face=sqrt( p*(p-a)*(p-b)*(p-c) );
    double R = (a*b*c)/(4*face);
    if (R>=500000 || R<=-1*500000) return {{0,0},R};
    //std::cout<<pr.first<<" "<<pr.second<<"\n";
    //std::cout<<vt.first<<" "<<vt.second<<"\n";
    //std::cout<<tr.first<<" "<<tr.second<<"\n";
    //std::cout<<a<<" "<<b<<" "<<c<<" "<<p<<" "<<face<<" "<<R<<"\nkraiii\n";
    std::pair< std::pair<double,double> , bool > sim1=simetrala(pr,vt);
    std::pair< std::pair<double,double> , bool > sim2=simetrala(tr,vt);
    double x,y;
    if (sim1.second==1)
    {
        x=sim1.first.first;
        y=sim2.first.first*x+sim2.first.second;
    }
    else if (sim2.second==1)
    {
        x=sim2.first.first;
        y=sim1.first.first*x+sim1.first.second;
    }
    else
    {
        x=(sim2.first.second-sim1.first.second)/(sim1.first.first-sim2.first.first);
        y=sim1.first.first*x+sim1.first.second;
    }
    //std::cout<<R<<" "<<x<<" "<<y<<"\nkraiii222\n";
    return { {x,y} , R };
}
void solve(int k)
{
    srand(123);
    double tmm=clock();
    int br=400;
    std::vector<std::pair<double, double>> vv;
    for (int q=0;q<br;q++)
    {
        vv.push_back(sample_star());
        //std::cout<<vv[q].first<<" "<<vv[q].second<<"\n";
    }
    random_shuffle(vv.begin(),vv.end());
    random_shuffle(vv.begin(),vv.end());
    std::vector<std::pair< std::pair<double,double> , double>> ans;
    while ((clock()-tmm)*0.5/CLOCKS_PER_SEC < 1 && ans.size()<=1'000'000)
    {
        int rd1=rand()%br;
        int rd2=rand()%br;
        int rd3=rand()%br;
        if (rd1==rd2 || rd2==rd3 || rd1==rd3) continue;
        std::pair< std::pair<double,double> , double> cur=findCirc(vv[rd1],vv[rd2],vv[rd3]);
            if (cur.second>500000 || cur.second<-1*500000)
            {
                continue;
            }
            if (cur.first.first>500000 || cur.first.first<-1*500000)
            {
                continue;
            }
            if (cur.first.second>500000 || cur.first.second<-1*500000)
            {
                continue;
            }

        ans.push_back(cur);
    }
    //std::cout<<ans.size();
    sort(ans.begin(),ans.end());
    std::vector<std::pair<long long,long long>> sr;
    long long cur=1,nc=0;
    for (int q=1;q<ans.size();q++)
    {
        if (absD(ans[q].first.first,ans[q-1].first.first)<=0.001 && absD(ans[q].first.second,ans[q-1].first.second)<=0.001 && absD(ans[q].second,ans[q-1].second)<=0.001)
        {
            cur++;
        }
        else
        {
            sr.push_back({cur,nc});
            nc=q;
            cur=1;
        }
    }
    sr.push_back({cur,nc});
    sort(sr.begin(),sr.end());
    reverse(sr.begin(),sr.end());
    int brr=0,lst=-1;
    for (int q=0;q<sr.size();q++)
    {
        if (brr>=k) return;
        brr++;
        int lst2=lst;
        lst=q;
        if (lst2==-1) answer( ans[sr[q].second].first.first , ans[sr[q].second].first.second , ans[sr[q].second].second );
        else if (dist( {ans[sr[q].second].first.first , ans[sr[q].second].first.second} , {ans[sr[lst2].second].first.first , ans[sr[lst2].second].first.second} )>=100) answer( ans[sr[q].second].first.first , ans[sr[q].second].first.second , ans[sr[q].second].second );
        else
        {
            brr--;
            lst=lst2;
        }
    }
    std::cout<<"NQMA\n";
    int xxx=1/0;
}

