#include "circle.h"
#include<bits/stdc++.h>
using namespace std;

struct comp {
    long double x;
    long double y;
};

comp mul(comp a, comp b) {
    comp c;
    c.x = a.x*b.x-a.y*b.y;
    c.y = a.x*b.y+b.x*a.y;
    return c;
}

comp conj(comp a) {
    comp c;
    c.x = a.x;
    c.y = -a.y;
    return c;
}

comp del(comp a, comp b) {
    comp c = mul(a,conj(b));
    c.x = c.x/(b.x*b.x+b.y*b.y);
    c.y = c.y/(b.x*b.x+b.y*b.y);
    return c;
}

comp add(comp a, comp b) {
    return {a.x+b.x,a.y+b.y};
}

comp subt(comp a, comp b) {
    return {a.x-b.x,a.y-b.y};
}

comp circum(comp a, comp b, comp c) {
    comp d = {0,0};
    d = add(d,mul(conj(a),mul(a,b)));
    d = add(d,mul(conj(b),mul(b,c)));
    d = add(d,mul(conj(c),mul(c,a)));
    d = subt(d,mul(conj(a),mul(a,c)));
    d = subt(d,mul(conj(b),mul(b,a)));
    d = subt(d,mul(conj(c),mul(c,b)));
    d.x = -d.x;
    d.y = -d.y;
    comp e = {0,0};
    e = add(e,mul(a,conj(b)));
    e = add(e,mul(b,conj(c)));
    e = add(e,mul(c,conj(a)));
    e = subt(e,mul(a,conj(c)));
    e = subt(e,mul(b,conj(a)));
    e = subt(e,mul(c,conj(b)));
    return del(d,e);
}

const double eps = 0.1;

double dist(comp a, comp b) {
    return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
}

void solve(int k) {
    vector<comp> haha(0);
    for(int i = 0; i < 500; i++) {
        pair<long double,long double> a = sample_star();
        haha.push_back({a.first,a.second});
    }
    random_shuffle(haha.begin(),haha.end());
    vector<pair<pair<double,double>,double>> ans(0);
    for(int i = 0; i < 500 && ans.size() < k; i++) {
        for(int j = i+1; j < 500 && ans.size() < k; j++) {
            for(int y = j+1; y < 500 && ans.size() < k; y++) {
                if(abs(haha[i].x) > 1e9 || abs(haha[j].x) > 1e9 || abs(haha[y].x) > 1e9) {
                    continue;
                }
                comp z = circum(haha[i],haha[j],haha[y]);
                if(abs(z.x) > 1e6 || abs(z.y) > 1e6) {
                    continue;
                }
                int br = 0;
                long double d = dist(z,haha[i]);
                for(int w = 0; w < haha.size(); w++) {
                    if(abs(haha[w].x) < 1e9 && abs(d-dist(haha[w],z)) < eps) {
                        br++;
                    }
                }
                if(br > 13) {
                    ans.push_back({{z.x,z.y},d});
                    for(int w = 0; w < haha.size(); w++) {
                        if(abs(d-dist(haha[w],z)) < eps) {
                            haha[w] = {1e18,1e18};
                        }
                    }

                }
            }
        }
    }
    for(int i = 0; i < ans.size(); i++) {
        answer(ans[i].first.first,ans[i].first.second,ans[i].second);
    }
}
