#include <bits/stdc++.h>
#include "circle.h"
#define endl '\n'

using namespace std;

const double eps = 1e-4;
struct Point
{
    double x, y;
    Point(){}
    Point(double x, double y)
        :x(x), y(y){}

    Point(pair <double, double> p)
        :x(p.first), y(p.second){}
};

struct Circle
{
    double xa, ya, r;
    Circle(){}
    Circle(double xa, double ya, double r)
        :xa(xa), ya(ya), r(r){}

    bool operator< (Circle other)
    {
        if (abs(this->xa - other.xa) > eps)
            return this->xa < other.xa;

        if (abs(this->ya - other.ya) > eps)
            return this->ya < other.ya;

        return this->r < other.r;
    }

    bool operator== (Circle other)
    {
        if (abs(this->xa - other.xa) > eps)
            return false;

        if (abs(this->ya - other.ya) > eps)
            return false;

        if (abs(this->r - other.r) > eps)
            return false;

       return true;
    }
};

Circle calculateCircleBy3Points(Point a, Point b, Point c)
{
    double A1 = 2.0*(b.x-a.x);
    double B1 = 2.0*(a.y-b.y);
    double C1 = b.y*b.y - a.y*a.y + b.x*b.x - a.x*a.x;

    double A2 = 2.0*(c.x-b.x);
    double B2 = 2.0*(b.y-c.y);
    double C2 = c.y*c.y - b.y*b.y + c.x*c.x - b.x*b.x;

    double ya = (C2*A1-C1*A2)/(B1*A2-A1*B2);
    double xa = (ya*B1+C1)/A1;

    double r = sqrt((a.x-xa)*(a.x-xa) + (a.y-ya)*(a.y-ya));

    return Circle(xa, ya, r);
}

vector <Point> points;
vector <Circle> circles;
vector < pair <int, int> > cnt;
void solve(int k)
{
    const int N = 400;
    for (int i = 0; i < N; i++)
    {
        Point a(sample_star());

        points.push_back(a);
    }

    for (int i = 0; i < N; i++)
    {
        for (int j = i+1; j < N; j++)
        {
            for (int k = j+1; k < N; k++)
            {
                circles.emplace_back(calculateCircleBy3Points(points[i], points[j], points[k]));
            }
        }
    }

    sort(circles.begin(), circles.end());

    Circle pre_circle = circles[0], curr_circle;
    int br = 1, startInd = 0;
    for (int i = 1; i < circles.size(); i++)
    {
        curr_circle = circles[i];
        if (curr_circle == pre_circle)
            br++;

        else
        {
            cnt.emplace_back(br, startInd);
            startInd = i;
            br = 1;
        }

        pre_circle = curr_circle;
    }

    cnt.emplace_back(br, startInd);

    sort(cnt.begin(), cnt.end());
    for (int i = cnt.size()-1; i >= cnt.size()-k; i--)
    {
        Circle circle = circles[cnt[i].second];
        answer(circle.xa, circle.ya, circle.r);
    }

}
