#include<iostream>
#include<cmath>
#include<algorithm>
#include<vector>
#include<set>
#include "circle.h"
using namespace std;
const double eps=1e-2;
vector<pair<pair<double,double>,double>>v;
set<pair<double,double>>s;
double dist(double x1,double y1,double x2,double y2)
{
    double a=(x1-x2);
    double b=(y1-y2);
    double c=a*a+b*b;
    return sqrt(c);
}
pair<pair<double,double>,double> one(double x1,double y1,double x2,double y2,double x3,double y3)
{
    double A1=2.0*(x2-x1),B1=2.0*(y2-y1),C1=x1*x1+y1*y1-x2*x2-y2*y2;

    if(A1==0)return {{0,0},-1};

    double A2=2.0*(x3-x1),B2=2.0*(y3-y1),C2=x1*x1+y1*y1-x3*x3-y3*y3;

    double A3=2.0*(x3-x2),B3=2.0*(y3-y2),C3=x2*x2+y2*y2-x3*x3-y3*y3;

    if((B2-A2/A1*B1)==0)return {{0,0},-1};

    double y=(A2/A1*C1-C2)/(B2-A2/A1*B1);

    double x=(-C1-B1*y)/A1;

    if(x*A3+y*B3+C3>=-eps && x*A3+y*B3+C3<=eps)
    {
        return {{x,y},dist(x,y,x1,y1)};
    }

    return {{0,0},-1};
}
void solve(int n)
{
    while(v.size()<n)
    {
        pair<double,double>cur=sample_star();
        double x=cur.first,y=cur.second;

        bool ok=0;
        for(int i=0;i<v.size();i++)
        {
            if(dist(x,y,v[i].first.first,v[i].first.second)>=v[i].second-eps && dist(x,y,v[i].first.first,v[i].first.second)<=v[i].second+eps){ok=1;break;}
        }

        if(ok)continue;

        for(auto p1:s)
        {
            for(auto p2:s)
            {
                if(p1.first==p2.first && p1.second==p2.second)continue;

                auto sega=one(p1.first,p1.second,p2.first,p2.second,x,y);

                if(sega.second!=-1)
                {
                    ok=1;
                    v.push_back(sega);
                    break;
                }
            }
            if(ok)break;
        }

        if(ok)
        {
            auto it=s.begin();
            while(it!=s.end())
            {
                auto p1=(*it);
                if(dist(p1.first,p1.second,v.back().first.first,v.back().first.second)>=v.back().second-eps && dist(p1.first,p1.second,v.back().first.first,v.back().first.second)<=v.back().second+eps)
                {
                    it=s.erase(it);
                }
                else it++;
            }
        }
        else s.insert(cur);
    }

    for(int i=0;i<n;i++)
    {
        answer(v[i].first.first,v[i].first.second,v[i].second);
    }
}
