#include <bits/stdc++.h>
#include "circle.h"
using namespace std;

bool eq(double d1,double d2)
{
    return (d1-d2)>=-0.0001&&(d1-d2)<=0.0001;
}

struct point
{
    double x,y;
    point(){}
    point(double _x,double _y)
    {
        x=_x;
        y=_y;
    }
    bool operator<(const point&p)const
    {
        return p.x<x;
    }
};

struct centre
{
    point p;
    double r;
    centre(){}
    centre(point _p,double _r)
    {
        p=_p;
        r=_r;
    }

    bool operator<(const centre&c)const
    {
        return c.r<r;
    }
    bool operator==(const centre&c)const
    {
        point p1=c.p;
        return eq(p1.x,p.x)&&eq(p1.y,p.y)&&eq(c.r,r);
    }
};

point find_(point p1,point p2,point p3)
{
    double con2=p2.x*p2.x-p1.x*p1.x+p2.y*p2.y-p1.y*p1.y;
    double con3=p3.x*p3.x-p1.x*p1.x+p3.y*p3.y-p1.y*p1.y;

    double y=(2*(p3.x-p1.x)*con2-2*(p2.x-p1.x)*con3)/(4*((p3.x-p1.x)*(p2.y-p1.y)-(p2.x-p1.x)*(p3.y-p1.y)));
    double x=(con2-2*(p2.y-p1.y)*y)/(2*(p2.x-p1.x));

    return {x,y};
}

double dist(point p1,point p2)
{
    return sqrt((p1.x-p2.x)*(p1.x-p2.x)+(p1.y-p2.y)*(p1.y-p2.y));
}

map<centre, int> mp;
set<point> s;

bool cmp(pair<centre,int> c1,pair<centre,int> c2)
{
    return c1.second>c2.second;
}

bool cmp1(centre c1,centre c2)
{
    if(eq(c1.p.x,c2.p.x))
    {
        if(eq(c1.p.y,c2.p.y))return c1.r-c2.r<0;
        return c1.p.y-c2.p.y<0;
    }
    return c1.p.x-c2.p.x<0;
}

void solve(int k)
{
    vector<point> v;
    for(int i=1;i<=300;i++)
    {
        pair<double,double> p=sample_star();
        v.push_back({p.first,p.second});
    }

    set<centre> s;
    vector<centre> all;

    for(int i=0;i<v.size();i++)
    {
        for(int j=i+1;j<v.size();j++)
        {
            for(int k=j+1;k<v.size();k++)
            {
                point p=find_(v[i],v[j],v[k]);
                centre c={p,dist(p,v[i])};
                all.push_back(c);
            }
        }
    }

    int cnt=0;
    vector<pair<centre,int> > ans;
    sort(all.begin(),all.end(),cmp1);
    for(int i=0;i<all.size();i++)
    {
        if(i==0||all[i]==all[i-1])cnt++;
        else
        {
            ans.push_back({all[i-1],cnt});
            cnt=1;
        }
    }
    ans.push_back({all[all.size()-1],cnt});

    sort(ans.begin(),ans.end(),cmp);
    for(int i=0;i<k;i++)
    {
        //cout<<ans[i].first.p.x<<" "<<ans[i].first.p.y<<" "<<ans[i].first.r<<" "<<ans[i].second<<endl;
        answer(ans[i].first.p.x,ans[i].first.p.y,ans[i].first.r);
    }
}
